<h1 id="title">Multi Application Online Profiling</h1>


Dependencies
-------------

* LibGD2 <http://libgd.bitbucket.org/>
* Node.js <http://nodejs.org/>
* Graphviz <http://graphviz.org/> (ideally with support for [GTS](http://gts.sourceforge.net/))
* An MPI implementation with PMPI support (and mpicc wrappers)
* Latex xcolor package for doxygen generation <http://www.ctan.org/pkg/xcolor>
* *OPTIONNAL* svUnitTest <https://github.com/svalat/svUnitTest>

Principle
-------------

Instrument one or several MPI program using an online analyzer which performs online data reduction.
Then visualize measurements in an interactive HTML interface.

Instalation
-------------

**First make sure that you have all the depencies** installed somewhere on the system or in the target prefix.

Then run :

		mkdir BUILD
		cd BUILD
		../configure --prefix=$HOME/malp
		make -j8
		make install

Usage
-------------

1. Launch your app in MPMD with the analyzer:

		mpirun -np 64 malp APP [APP_ARGS] : -np 64 malp_an

2. Launch the analysis server:

		MALP_PORT=8080 malp_server


3. Open your default browser to this page:

		x-www-browser http://127.0.0.1:8080

4. Go to the performance catalog and upload the *MALP_trace.json* file generated during step **1**

5. Load the newly upload trace from the performance catalog

6. Explore your trace =)

EXTRA
------------

1. You can write a config file configuring instrumentation with:

		malp_an -w

2. Edit the file **./malp_an.conf** for example to activate POSIX instrumentation

MAP PLUGINS
-------------

1. MALP installs sample plugins in the **$PREFIX/lib/malp\_map\_plugins/** directory

2. To activate MAP plugin support simply export the plugin environment variable:

		export MAP_PLUGIN_PREFIX=$PREFIX/lib/malp_map_plugins/

3. You can change sampling frequency in milliseconds with:

		export MAP_PLUGIN_FREQ=10000

4. If activated you should get an output telling so when running MALP:

		## Loading MAP plugins :
		Loading plugin 'interrupts.xml' ...
		Loading plugin 'io.xml' ...
		## Done

5. Data will be available in the MAP Plugins tab of the interface

FAQ
-------------


1. Install fails: 
	* Do not run directly *make install*, it will fail as some files have to be generated
	* If there are errors in {BUILD}/src/Instrum/Posix_Wrapper.c : a quick workaroud is to remove the functions which are conflicting.
	  If it is not sufficient simply disable POSIX wrapping with --disable-posix
	* Send me an email (see Contact section)
	
2. I don't want to run in MPMD, MALP supports a fake MPMD mode with *--enable-mpmd-compat*

3. I want to pack node.js and the analysis server in a single static executable (malp\_server) while encrypting the JavaScript code: use the *--enable-node-embedding* flag.


Contact
-------------

Jean-Baptiste BESNARD <jbaptistebesnard@gmail.com>












































































<script src="src/MALP_Node/res/scripts/jquery.js"></script>

<script>
	var s = 0;
	window.setInterval(function(){
	//$("#title").hide();
	var sin = Math.sin(s/5).toFixed(2);
	if(20 < s)
	{
		$("#title").html("Multi Application Online Profiling");
	}
	else
	{
		var i = 0;
		var sp = "";
		for( i = 0 ; i < Math.floor(sin*20) ; i++ )
		{
			sp += "&nbsp;";
		}
		$("#title").html("M"+sp+"A"+sp+"L"+sp+"P");
	}
	//$("#title").fadeIn(2000);
	s = (s+1)%50;
	}, 100);
</script>



<style type="text/css">
	h1#title
	{
		text-align: center;
		color: white;
		font-size: 42px;
		text-shadow: 0px 3px 0px rgba(0,0,0,0.15), 0px 14px 10px rgba(0,0,0,0.15), 0px 24px 2px rgba(0,0,0,0.1), 0px 30px 34px rgba(0,0,0,0.1);
	}
	body
	{
		background-color: #DDD;
		color: black;
	}
	h2
	{
		width: 20%;
		border-bottom: 1px solid black;
	}
</style>

