from easybuild.easyblocks.generic.configuremake import ConfigureMake
from easybuild.tools.run import run_cmd

class EB_MALP(ConfigureMake):

   def configure_step(self):
      # run autoconf to generate configure script
      cmd = "autoconf"
      run_cmd(cmd)

      deps = { 
         'OTF2' : ['--with-otf2-config=%s/bin'], 
	 'GD' : ['--with-gd2=%s'],
	 'nodejs' : ['--with-nodejs=%s']
	}	

      for (dep_name, dep_opts) in deps.items():
          dep_root = get_software_root(dep_name)
          if dep_root:
             for dep_opt in dep_opts:
                self.cfg.update('configopts', dep_opt % dep_root)   
	
      # configure
      super(EB_MALP, self).configure_step()
