#ifndef MPI_PROFILE_H
#define MPI_PROFILE_H

#include <stdint.h>

#include "Event_Desc.h"
#include "Collector.h"
#include "Shared_Cache.h"

#include "Hash_Table.h"

struct MPI_Profile_acc
{
	/* Its a bit redundant but saves some 
	 * allocation complexity for a few KB */

	uint64_t associated_tid;

	uint64_t hits[T_MPI_COUNT];
	uint64_t time[T_MPI_COUNT];
	uint64_t size[T_MPI_COUNT];

};


#define MPI_PROF_COLL_AVOID 2
struct MPI_Profile_acc_cell
{
	struct Hash_Table_Internal _____;
	struct MPI_Profile_acc accs[MPI_PROF_COLL_AVOID];
};

struct MPI_Profile
{
	struct MPI_Profile_acc global_acc;
	struct Hash_Table per_stream_profiles;
};



int  MPI_Profile_init_coll( struct Collector * coll );
int  MPI_Profile_release_coll( struct Collector * coll );
void MPI_Profile_push_event(struct MALP_Trace_Event *, void *);
int  MPI_Profile_reduce( struct Collector * coll );
int  MPI_Profile_accumulate( struct Collector * coll );

void MPI_Profile_init(struct Collector *coll, uint64_t partition_id);

#endif
