#ifndef MPI_SECTION_COL_H
#define MPI_SECTION_COL_H

#include <stdint.h>

#include "Event_Desc.h"
#include "Collector.h"
#include "Wrapped_Symbols.h"
#include "Hash_Table.h"
#include "MPI_Section_tree.h"
#include "Spinlock.h"

struct MPI_Section_coll_entry
{


	MALP_Spinlock lock;
	struct MPI_Section_tree tree;
	int rank;
	struct MPI_Section_tree * current_tree;
};

#define MPI_SECTION_COLL_AVOID 5

struct MPI_Section_coll_entry_cell
{
	struct Hash_Table_Internal _____;
	struct MPI_Section_coll_entry ent[MPI_SECTION_COLL_AVOID];
};

int MPI_Section_coll_entry_init( struct MPI_Section_coll_entry *ent, uint64_t rank );
int MPI_Section_coll_entry_release( struct MPI_Section_coll_entry *ent );


struct MPI_Section_coll_ctx
{
	MALP_Spinlock ht_lock;
	struct Hash_Table ht;
};

void MPI_Section_coll_ctx_init( struct MPI_Section_coll_ctx * ctx );
void MPI_Section_coll_ctx_release( struct MPI_Section_coll_ctx * ctx );

int  MPI_Section_init_coll( struct Collector * coll );
int  MPI_Section_release_coll( struct Collector * coll );
void MPI_Section_push_event(struct MALP_Trace_Event *, void *);
int  MPI_Section_reduce( struct Collector * coll );
int  MPI_Section_accumulate( struct Collector * coll );

void MPI_Section_init(struct Collector *coll, uint64_t partition_id);


#endif /* MPI_SECTION_COL_H */
