#ifndef __MALP_OMPT_PROFILE_H__
#define __MALP_OMPT_PROFILE_H__

#include "config.h"

#if HAVE_OMPT_H

#include <stdint.h>

#include "OMPT_Events.h"
#include "Event_Desc.h" 
#include "Collector.h"
#include "Shared_Cache.h"
#include "Hash_Table.h"

struct OMPT_Profile_acc
{
	/* Its a bit redundant but saves some 
	 * allocation complexity for a few KB */

	uint64_t associated_tid;
	
	uint64_t hits[T_OMPT_COUNT];
	uint64_t time[T_OMPT_COUNT];
	uint64_t size[T_OMPT_COUNT];

};


#define OMPT_PROF_COLL_AVOID 2
struct OMPT_Profile_acc_cell
{
	struct Hash_Table_Internal _____;
	struct OMPT_Profile_acc accs[OMPT_PROF_COLL_AVOID];
};

struct OMPT_Profile
{
	struct OMPT_Profile_acc global_acc;
	struct Hash_Table per_stream_profiles;
};

void OMPT_Profile_init(struct Collector *coll, uint64_t partition_id);

#endif /* HAVE_OMPT_H */

#endif /* __MALP_OMPT_PROFILE_H__ */
