/* ############################ MALP License ############################## */
/* # Fri Jan 18 14:00:00 CET 2013                                         # */
/* # Copyright or (C) or Copr. Commissariat a l'Energie Atomique          # */
/* #                                                                      # */
/* # This software is governed by the CeCILL-C license under French law   # */
/* # and abiding by the rules of distribution of free software.  You can  # */
/* # use, modify and/ or redistribute the software under the terms of     # */
/* # the CeCILL-C license as circulated by CEA, CNRS and INRIA at the     # */
/* # following URL http://www.cecill.info.                                # */
/* #                                                                      # */
/* # The fact that you are presently reading this means that you have     # */
/* # had knowledge of the CeCILL-C license and that you accept its        # */
/* # terms.                                                               # */
/* #                                                                      # */
/* # Authors:                                                             # */
/* #   - BESNARD Jean-Baptiste jean-baptiste.besnard@cea.fr               # */
/* #                                                                      # */
/* ######################################################################## */
#ifndef BASIC_EVENT_TYPES
#define BASIC_EVENT_TYPES

#include "MPI_Events.h"


static inline int Event_is_MPI_p2p( int type )
{
	switch( type )
	{
		case T_MPI_SEND:
		case T_MPI_ISEND :
		case T_MPI_IBSEND :
		case T_MPI_IRSEND :
		case T_MPI_ISSEND :
		case T_MPI_BSEND :
		case T_MPI_SSEND :
		case T_MPI_RSEND :
		case T_MPI_RECV :
		case T_MPI_IRECV :
			return 1;
		default :
			return 0;
	}
}


static inline int Event_is_MPI_send( int type )
{
	switch( type )
	{
		case T_MPI_SEND:
		case T_MPI_ISEND :
		case T_MPI_IBSEND :
		case T_MPI_IRSEND :
		case T_MPI_ISSEND :
		case T_MPI_BSEND :
		case T_MPI_SSEND :
		case T_MPI_RSEND :
			return 1;
		default :
			return 0;
	}
}


static inline int Event_is_MPI_recv( int type )
{
	if( (type == T_MPI_RECV) || (type == T_MPI_IRECV) )
		return 1;

	return 0;
}

static inline int Event_is_MPI_coll( int type )
{
	switch( type )
	{
		case T_MPI_ALLGATHER :
		case T_MPI_ALLGATHERV :
		case T_MPI_ALLREDUCE :
		case T_MPI_ALLTOALL :
		case T_MPI_ALLTOALLV :
		case T_MPI_BARRIER :
		case T_MPI_BCAST :
		case T_MPI_GATHER :
		case T_MPI_GATHERV :
		case T_MPI_REDUCE :
		case T_MPI_REDUCE_SCATTER :
		case T_MPI_SCAN :
		case T_MPI_SCATTER :
		case T_MPI_SCATTERV :
			return 1;
		default :
			return 0;
	}
}

static inline int Event_is_MPI_probe( int type )
{
	switch( type )
	{
		case T_MPI_PROBE :
		case T_MPI_IPROBE :
			return 1;
		default :
			return 0;
	}
}

static inline int Event_is_MPI_wait( int type )
{
	switch( type )
	{
		case T_MPI_WAITALL :
		case T_MPI_WAIT :
		case T_MPI_WAITANY :
		case T_MPI_WAITSOME :
			return 1;
		default :
			return 0;
	}
}





#endif /* BASIC_EVENT_TYPES */
