/* ############################ MALP License ############################## */
/* # Fri Jan 18 14:00:00 CET 2013                                         # */
/* # Copyright or (C) or Copr. Commissariat a l'Energie Atomique          # */
/* #                                                                      # */
/* # This software is governed by the CeCILL-C license under French law   # */
/* # and abiding by the rules of distribution of free software.  You can  # */
/* # use, modify and/ or redistribute the software under the terms of     # */
/* # the CeCILL-C license as circulated by CEA, CNRS and INRIA at the     # */
/* # following URL http://www.cecill.info.                                # */
/* #                                                                      # */
/* # The fact that you are presently reading this means that you have     # */
/* # had knowledge of the CeCILL-C license and that you accept its        # */
/* # terms.                                                               # */
/* #                                                                      # */
/* # Authors:                                                             # */
/* #   - BESNARD Jean-Baptiste jean-baptiste.besnard@cea.fr               # */
/* #                                                                      # */
/* ######################################################################## */

#include "Binary_Tree.h"

void Binary_Tree_init(struct Binary_Tree *bt, int rank, int size)
{

	bt->rank = rank;
	bt->size = size;


	/* Build a binary tree  */

	int tree_rank = rank + 1;

	/* 0 Has no parent */
	if( rank )
	{
		bt->parent = (tree_rank / 2) - 1;
	}
	else
	{
		bt->parent = -1;
	}

	/* Is left child in limits */
	if( ( ( tree_rank * 2 ) - 1 ) < size )
	{
		bt->left_child = ( ( tree_rank * 2 ) - 1 );
	}
	else
	{
		bt->left_child = -1;
	}

	/* Is right child in limits */
	if( ( tree_rank * 2 ) < size )
	{
		bt->right_child = ( tree_rank * 2 );
	}
	else
	{
		bt->right_child = -1;
	}

}



void Binary_Tree_release(struct Binary_Tree *bt)
{
	bt->rank = -1;
	bt->size = 0;
	bt->parent = -1;
	bt->left_child = -1;
	bt->right_child = -1;
}
