#ifndef __MALP_OPA_ATOMICS_H__
#define __MALP_OPA_ATOMICS_H__

#include "opa_primitives.h"

// Rename the OPA functions into MALP_atomics ones

/* INTEGER func */
#define MALP_atomics_store_int           OPA_store_int
#define MALP_atomics_load_int            OPA_load_int
#define MALP_atomics_swap_int            OPA_swap_int
#define MALP_atomics_add_int             OPA_add_int
#define MALP_atomics_cas_int             OPA_cas_int
#define MALP_atomics_incr_int            OPA_incr_int
#define MALP_atomics_decr_int            OPA_decr_int
#define MALP_atomics_decr_and_test_int   OPA_decr_and_test_int
#define MALP_atomics_fetch_and_add_int   OPA_fetch_and_add_int
#define MALP_atomics_fetch_and_incr_int  OPA_fetch_and_incr_int
#define MALP_atomics_fetch_and_decr_int  OPA_fetch_and_decr_int

/* POINTER func */
#define MALP_atomics_load_ptr            OPA_load_ptr
#define MALP_atomics_store_ptr           OPA_store_ptr
#define MALP_atomics_cas_ptr             OPA_cas_ptr
#define MALP_atomics_swap_ptr            OPA_swap_ptr

/* Barrier */
#define MALP_atomics_write_barrier       OPA_write_barrier
#define MALP_atomics_read_barrier        OPA_read_barrier
#define MALP_atomics_read_write_barrier  OPA_read_write_barrier
#define MALP_atomics_pause               OPA_busy_wait

#define MALP_ATOMICS_INT_T_INIT OPA_INT_T_INITIALIZER
#define MALP_ATOMICS_PTR_T_INIT OPA_PTR_T_INITIALIZER

#endif /* __MALP_OPA_ATOMICS_H__ */
