/* ############################ MALP License ############################## */
/* # Fri Jan 18 14:00:00 CET 2013                                         # */
/* # Copyright or (C) or Copr. Commissariat a l'Energie Atomique          # */
/* #                                                                      # */
/* # This software is governed by the CeCILL-C license under French law   # */
/* # and abiding by the rules of distribution of free software.  You can  # */
/* # use, modify and/ or redistribute the software under the terms of     # */
/* # the CeCILL-C license as circulated by CEA, CNRS and INRIA at the     # */
/* # following URL http://www.cecill.info.                                # */
/* #                                                                      # */
/* # The fact that you are presently reading this means that you have     # */
/* # had knowledge of the CeCILL-C license and that you accept its        # */
/* # terms.                                                               # */
/* #                                                                      # */
/* # Authors:                                                             # */
/* #   - BESNARD Jean-Baptiste jean-baptiste.besnard@cea.fr               # */
/* #                                                                      # */
/* ######################################################################## */
#ifndef OTF_EVENT_FORGE_H
#define OTF_EVENT_FORGE_H

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdint.h>
#include <string.h>
#include "Event_Desc.h"



/**
 * @ingroup OTF2_Internal_
 * @brief OTF2 id enumeration for basic information on archive
 */
typedef enum {
    MALP_OTF_ANALYSER_EMPTY_STRING = 0,
    MALP_OTF_ANALYSER_NODE_CLASS_STRING,
    MALP_OTF_ANALYSER_ROOT_NODE,
    MALP_OTF_ANALYSER_PROGRAM_CLASS_STRING,
    MALP_OTF_ANALYSER_FAKE_FUNCTION,

    MALP_OTF_ANALYSER_INFO_COUNT
} OTF_Event_reserved_str;

static const char * const OTF_Event_names[MALP_OTF_ANALYSER_INFO_COUNT]=
{
	"",
	"Node",
	"MALP Instrumented program",
	"Malp_Analysis",
	"Fake Function"
};

#define OTF_EVENT_COUNT (MALP_OTF_ANALYSER_INFO_COUNT + T_MPI_COUNT + T_POSIX_COUNT)

static inline uint64_t OTF_Event_count()
{
	return OTF_EVENT_COUNT;
}

char * OTF_Event_resolve( uint64_t str_id );
int OTF_Event_set( uint64_t str_id , char *data );


int OTF_Event_forge( struct MALP_Trace_Event *otf_event, OTF_Event_type enterleave,
                      MALP_Trace_event_type type, uint64_t subtype );
                      
void  OTF_Event_print( struct MALP_Trace_Event *otf_event);


void OTF_Event_forge_init();
void OTF_Event_forge_release();


#ifdef __cplusplus
}
#endif

#endif /* OTF_EVENT_FORGE_H */
