/* ############################ MALP License ############################## */
/* # Fri Jan 18 14:00:00 CET 2013                                         # */
/* # Copyright or (C) or Copr. Commissariat a l'Energie Atomique          # */
/* #                                                                      # */
/* # This software is governed by the CeCILL-C license under French law   # */
/* # and abiding by the rules of distribution of free software.  You can  # */
/* # use, modify and/ or redistribute the software under the terms of     # */
/* # the CeCILL-C license as circulated by CEA, CNRS and INRIA at the     # */
/* # following URL http://www.cecill.info.                                # */
/* #                                                                      # */
/* # The fact that you are presently reading this means that you have     # */
/* # had knowledge of the CeCILL-C license and that you accept its        # */
/* # terms.                                                               # */
/* #                                                                      # */
/* # Authors:                                                             # */
/* #   - BESNARD Jean-Baptiste jean-baptiste.besnard@cea.fr               # */
/* #                                                                      # */
/* ######################################################################## */
#include "Spinlock.h"

#include <pthread.h>

int MALP_Spinlock_trylock(MALP_Spinlock * mutex)
{
	unsigned int *p = (unsigned int *) mutex;
	return !tracelib_test_and_set(p);
}


int MALP_Spinlock_lock(MALP_Spinlock * mutex)
{
	unsigned int *p = (unsigned int *) mutex;
	while (tracelib_test_and_set(p)) {

                int cnt = 0;

		do {
                    if(!(cnt%16))
                        pthread_yield();

                    cnt++;
		    cpu_relax();
		} while (*p);
	}
	return 0;
}

int MALP_Spinlock_unlock(MALP_Spinlock * mutex)
{
	*mutex = 0;
	return 0;
}
