/* ############################ MALP License ############################## */
/* # Fri Jan 18 14:00:00 CET 2013                                         # */
/* # Copyright or (C) or Copr. Commissariat a l'Energie Atomique          # */
/* #                                                                      # */
/* # This software is governed by the CeCILL-C license under French law   # */
/* # and abiding by the rules of distribution of free software.  You can  # */
/* # use, modify and/ or redistribute the software under the terms of     # */
/* # the CeCILL-C license as circulated by CEA, CNRS and INRIA at the     # */
/* # following URL http://www.cecill.info.                                # */
/* #                                                                      # */
/* # The fact that you are presently reading this means that you have     # */
/* # had knowledge of the CeCILL-C license and that you accept its        # */
/* # terms.                                                               # */
/* #                                                                      # */
/* # Authors:                                                             # */
/* #   - BESNARD Jean-Baptiste jean-baptiste.besnard@cea.fr               # */
/* #                                                                      # */
/* ######################################################################## */


#ifndef LOCUS_H
#define LOCUS_H

#include <stdint.h>

/**
 * @ingroup Data_Model_
 * @brief Structure defining the global location
 *
 * @todo only Pack_Locus is actually used
 *
 */
struct Global_Locus
{
	uint32_t partition;     /**< @brief the partition id */
	uint32_t application;   /**< @brief the application id */
	uint32_t rank;          /**< @brief the rank */
	uint32_t stream_id;     /**< @brief the stream id */
	uint32_t phase_id;      /**< @brief the phase id */

};

/**
 * @ingroup Data_Model_
 * @brief Structure defining a location for an event pack
 */
struct Pack_Locus
{
	uint32_t partition;     /**< @brief the partition id */
	uint32_t application;   /**< @brief tha application id */
};

/**
 * @ingroup Data_Model_
 * @brief Structure defining a location for an event
 *
 * @todo only Pack_Locus is actually used
 */
struct Event_Locus
{
	uint32_t rank;      /**< @brief the source rank */
	uint32_t stream_id; /**< @brief the id of the stream where the event is sent */
	uint32_t phase_id;  /**< @brief the phase id */
};


#endif /* LOCUS_H */

