/* ############################ MALP License ############################## */
/* # Fri Jan 18 14:00:00 CET 2013                                         # */
/* # Copyright or (C) or Copr. Commissariat a l'Energie Atomique          # */
/* #                                                                      # */
/* # This software is governed by the CeCILL-C license under French law   # */
/* # and abiding by the rules of distribution of free software.  You can  # */
/* # use, modify and/ or redistribute the software under the terms of     # */
/* # the CeCILL-C license as circulated by CEA, CNRS and INRIA at the     # */
/* # following URL http://www.cecill.info.                                # */
/* #                                                                      # */
/* # The fact that you are presently reading this means that you have     # */
/* # had knowledge of the CeCILL-C license and that you accept its        # */
/* # terms.                                                               # */
/* #                                                                      # */
/* # Authors:                                                             # */
/* #   - BESNARD Jean-Baptiste jbbesnard@paratools.fr                     # */
/* #                                                                      # */
/* ######################################################################## */
#ifndef MPI_SECTION_EVENT_H
#define MPI_SECTION_EVENT_H

#ifdef __cplusplus
extern "C"
{
#endif

typedef enum
{
	MPI_SECTION_BEGIN,	/** Starting a Section */
	MPI_SECTION_END,     /** Ending a Section */
	MPI_SECTION_TYPE_COUNT
}MPI_Section_type;

static const char * const MPI_Section_type_name[MPI_SECTION_TYPE_COUNT] = 
{
	"Begin",
	"End"
};

/** Event used to carry MPI_Section events */
struct MPI_Section_event
{
	char label[64];
	MPI_Section_type type;
};


#ifdef __cplusplus
}
#endif

#endif /* MPI_SECTION_EVENT_H */
