/* ############################ MALP License ############################## */
/* # Fri Jan 18 14:00:00 CET 2013                                         # */
/* # Copyright or (C) or Copr. Commissariat a l'Energie Atomique          # */
/* #                                                                      # */
/* # This software is governed by the CeCILL-C license under French law   # */
/* # and abiding by the rules of distribution of free software.  You can  # */
/* # use, modify and/ or redistribute the software under the terms of     # */
/* # the CeCILL-C license as circulated by CEA, CNRS and INRIA at the     # */
/* # following URL http://www.cecill.info.                                # */
/* #                                                                      # */
/* # The fact that you are presently reading this means that you have     # */
/* # had knowledge of the CeCILL-C license and that you accept its        # */
/* # terms.                                                               # */
/* #                                                                      # */
/* # Authors:                                                             # */
/* #   - BESNARD Jean-Baptiste jbbesnard@paratools.fr                     # */
/* #                                                                      # */
/* ######################################################################## */
#include <stdio.h>
#include <VMPI.h>

#include "Event_Desc.h"
#include "Timer.h"
#include "Event_Pack.h"
#include "Stream_MGR.h"

int MPI_Section_enter_cb( char * label, uint64_t *arg  )
{
	struct MALP_Trace_Event event;
	
	uint64_t _begin =  Timer_tsc ();
	*arg = _begin;

	MALP_Trace_Event_fill( &event, MALP_EVENT_MPI_SECTION, _begin, 0 );
	
	memcpy( event.event.mpi_section.label, label, 64 );
	event.event.mpi_section.type = MPI_SECTION_BEGIN;
	
	/* Submit event if MPI instrumented */
	Event_Packer_push(&event);
		
		
	return MPI_SUCCESS;
}


int MPI_Section_leave_cb( char * label, uint64_t begin  )
{
	struct MALP_Trace_Event event;

	uint64_t _end =  Timer_tsc ();

	MALP_Trace_Event_fill( &event, MALP_EVENT_MPI_SECTION, _end, _end - begin );

	memcpy( event.event.mpi_section.label, label, 64 );
	event.event.mpi_section.type = MPI_SECTION_END;

	/* Submit event if MPI instrumented */
	Event_Packer_push(&event);
	
	return MPI_SUCCESS;
}
