var catalog = module.require("malp_catalog").catalog;
var timeMatrix = require("malp_rendering").timeMatrix;
var timeMatrixScale = require("malp_rendering").timeMatrixScale;
var meta = require("malp_rendering").metadata;
var conv = require("malp_rendering").converter;

<page uri="/mapplugin" parent="/" title="MAP Plugins" />



<body>
    <script type="text/javascript" src="/scripts/jquery.js"></script>
	<script type="text/javascript" src="/scripts/d3.js"></script>
	<link rel="stylesheet" type="text/css" href="/css/nv.d3.css"/>
	<script type="text/javascript" src="/scripts/nv.d3.js"></script>

	<server>

	//Acquire the collector

	var current_prof = catalog.getProfile();

	if( current_prof == undefined )
	{
	</server>
		<h1>No profile loaded</h1>
	<server>
		return;
	}
	else
	{
		res.write("<h1>MAP Time Series</h1>");
	}

	var plugins = current_prof["map"];

	//Now generate Group list 
	var groups=[];
	
	
	for( var i = 0 ; i < plugins.length ; i++ )
	{
		var plugin = plugins[i];

		for( var j = 0 ; j < plugin.groups.length; j++ )
			groups.push( plugin.groups[j] );
	}
	
	//Now generate metrics lookup table
	var metrics={};
	
	
	for( var i = 0 ; i < plugins.length ; i++ )
	{
		var plugin = plugins[i];

		
		for( var j = 0 ; j < plugin.metrics.length; j++ )
		{
			if( plugin.metrics[j] )
				metrics[plugin.metrics[j].id] = plugin.metrics[j];
		}
	}
	
	
	var local_id = 0;
	var to_render = [];
	
	//Now output Groups and their metrics
	for( var i = 0 ; i < groups.length; i++ )
	{
		var g = groups[i];
		
		res.write( "<h2>" + g.description + "</h2>" );
	
	
		for( var j = 0 ; j < g.group.length; j++ )
		{
			var m = metrics[ g.group[j] ];

			res.write(  m.display_name  + ": " +  m.description + "<br>");
			
			res.write("<div class='graphcontainer'><svg width='80%' height=200 id='graph" + local_id + "'></svg></div>\n");
			to_render.push( { "id" : "graph" + local_id , "metric" : m } );
			
			local_id++;
		}
	
	
	}

	</server>
	
		<script type="text/javascript">

		function gen_data_x_y( matrix, normalize )
		{
				var i =0;
				var ret = [];
				var quantum = matrix.q;
				var data = matrix.data[0];
				
				for( i = 0 ; i < data.length ; i++ )
				{
					var val = data[i];
					
					if( val == 0 || val == 0.0 )
						continue;
					
					ret.push({ x : i * quantum , y : val });
				}
				
				return ret;
		};
		
		
		
		function gen_graph_from_metric( targetid , metric )
		{
			 var chart = nv.models.lineChart()
						.margin({left: 100, right: 100}) //Adjust chart margins to give the x-axis some breathing room.
						.useInteractiveGuideline(true) //We want nice looking tooltips and a guideline!
						.showLegend(true) //Show the legend, allowing users to turn on/off line series.
						.showYAxis(true) //Show the y-axis
						.showXAxis(true);

			chart.xAxis.axisLabel('Time (s)')
					   .tickFormat(d3.format(',r'));
						   

			chart.yAxis.axisLabel(metric.type)
					   .tickFormat(d3.format('.02f'));

			 
			/* Done setting the chart up? Time to render it!*/
			var x_y = gen_data_x_y( metric.measures , metric.divide_by_sample );	

			var myData = [{
				key : metric.display_name,
				values: x_y,
				color: metric.color
			}];
			 
			d3.select(targetid) //Select the <svg> element you want to render the chart in.
			.datum(myData) //Populate the <svg> element with chart data...
			.call(chart); //Finally, render the chart!
			 
			//Update the chart when window resizes.
			nv.utils.windowResize(function() { chart.update() });

			
		}
		
		$(document).ready( function()
		{
			<server>
				for( var i  = 0 ; i < to_render.length ; i++ )
				{
					var r = to_render[i];
					
					res.write("gen_graph_from_metric(" + r.id + "," + JSON.stringify( r.metric ) + ");\n");
				}
			
			</server>
		});
		
	</script>


	

</body>

