var catalog = module.require("malp_catalog").catalog;
var timeMatrix = require("malp_rendering").timeMatrix;
var timeMatrixScale = require("malp_rendering").timeMatrixScale;
var meta = require("malp_rendering").metadata;
var conv = require("malp_rendering").converter;

<page uri="/timematrix" parent="/" title="Time Matrix" />


<view uri="genall">
	<script type="text/javascript" src="/scripts/jquery.js"></script>
	
	<server>
		if( !GET["f"] )
			return;
	</server>
	
	<div id="tms"></div>
	
	<script>

	<server>
		res.write( "var current_function = \"" + GET["f"] + "\";");
	</server>

		$(document).ready( function()
		{
				 $.ajax({url: "/timematrix/getmatrix?f="+current_function+"&t=hits&s=temperature&g=0&l=0&body_only=1" }).done(function( data ) {
					 if( data == "null" )
					 {
						 return;
					 }
					 
					 $("#tms").append(data);
					 
					 $.ajax({url: "/timematrix/getmatrix?f="+current_function+"&t=time&s=temperature&g=0&l=0&body_only=1" }).done(function( data ) {
							if( data == "null" )
							{
								return;
							}
							 
						   $("#tms").append(data);
						 
						   $.ajax({url: "/timematrix/getmatrix?f="+current_function+"&t=size&s=temperature&g=0&l=0&body_only=1" }).done(function( data ) {
								 if( data == "null" )
								 {
									 return;
								 }
								 
								 $("#tms").append(data);
							});
					});
				});
				 
				

		});
	</script>
</view>



<body>

	<server>

	//Acquire the collector

	var current_prof = catalog.getProfile();

	if( current_prof == undefined )
	{
	</server>
		<h1>No profile loaded</h1>
	<server>
		return;
	}

	var collector = current_prof["Time_Matrix"];

	//Now generate function list 

	var function_list = [];
	var i;

	var list = collector.measures;

	if( list == undefined )
	{
		list = collector.mpi;
	}



	for( i = 0 ; i < list.length ; i++ )
	{
		function_list.push( { "name" : list[i].name , "function_class" : "mpi" } );
	}


	res.write("<script>\n");
	res.write("var current_function = '" + function_list[0].name  + "';\n");
	res.write("var current_type = 'time';\n");
	res.write("var current_scale = 'temperature';\n");
	res.write("var current_gauss = '0';\n");
	res.write("var current_logscale = '0';\n");
	res.write("</script>\n");



	</server>

	<div>
	<select id='function'>
		<server>
			for( i = 0 ; i < function_list.length ; i++ )
			{
				res.write("<option value='" + function_list[i].name + "'>" + function_list[i].name + "</option>");
			}
		</server>
	</select>

	<select id='type'>
		<option value="time">Time</option>
		<option value="hits">Hits</option>
		<option value="size">Size</option>
	</select>

	<select id='scale'>
		<option value="temperature">Temperature</option>
		<option value="fire">Fire</option>
		<option value="ice">Ice</option>
		<option value="greyscale">Greyscale</option>
		<option value="three levels">Three Levels</option>
		<option value="three levels linear">Three Levels Linear</option>
		<option value="three levels linear narrow">Three Levels Narrow Average</option>
		<option value="good and evil">Good and Evil</option>
	</select>

	<select id='gauss'>
		<option value="0">Gauss 0</option>
		<option value="1">Gauss 1</option>
		<option value="2">Gauss 2</option>
		<option value="3">Gauss 3</option>
		<option value="4">Gauss 4</option>
		<option value="5">Gauss 5</option>
		<option value="6">Gauss 6</option>
		<option value="7">Gauss 7</option>
		<option value="8">Gauss 8</option>
		<option value="9">Gauss 9</option>
	</select>

	<select id='logscale'>
		<option value="0">Linear Scale</option>
		<option value="1">Logarithmic Scale</option>
	</select>

	<button id='load'>Add</button>

	</div> 

	<div id="tms"></div>


	<script type="text/javascript" src="/scripts/jquery.js"></script>
	<script>


	$(document).ready( function()
	{
		
		$('#function').bind('change', function ()
		{
			current_function = this.value;
		});
		
		$('#type').bind('change', function ()
		{
			current_type = this.value;
		});

		$('#scale').bind('change', function ()
		{
			current_scale = this.value;
		});

		$('#gauss').bind('change', function ()
		{
			current_gauss = this.value;
			
		});
		
		$('#logscale').bind('change', function ()
		{
			current_logscale = this.value;
			
		});

		
		$('#load').bind('click', function ()
		{
			     $.ajax({url: "/timematrix/getmatrix?f="+current_function+"&t="+ current_type +"&s="+ current_scale +"&g="+ current_gauss + "&l=" + current_logscale + "&body_only=1" }).done(function( data ) {
				 
				 if( data == "null" )
				 {
					 alert("No attribute " + current_type + " for " + current_function );
					 return;
				 }
				 
				 $("#tms").append(data);
				 
				//We bind each time to have effect on new entries 
				$("div.container").bind('click', function ()
				{
					var id = pos = $(this).attr("id");
					$("#" + id).remove();
				});
			  });
			 
		});
		
	});



	</script>

</body>



var MAT_ID = 0;

<view uri="getmatrix">
	<server>
		var function_name = GET.f;
		var type = GET.t;
		var scale = GET.s;
		var gauss = GET.g;
		var log = GET.l;
		
		if( !function_name || !type )
		{
			return;
		}
		
		if(!scale)
			scale = "temperature";
			
		if(!gauss)
			gauss = 0;
			
		if(!log)
			log = 0;
			
		if( !get_density_data( function_name, type ) )
		{
			res.write("null");
			return;
		}
		
		var local_id = MAT_ID++;
		
		res.write("<div id='mat" + local_id + "' class='container loadingcontainer' matid='" + local_id + "'><h1>"+ function_name + " in  " + type + "</h1> (scale " + scale + ", gauss " +  gauss + ", logscale " + log + ")");		
		
		//Generate Matrix 
		res.write("<br><img width='100%' height='400px' src='/timematrix/map?f=" + function_name + '&t=' + type + '&s=' + scale + '&g=' + gauss + '&ls=' + log + "'>");
		
		//Generate Scale
		var minmax = timeMatrixMinMax( function_name, type );
		res.write("<div class='centered'><table width='100%'><tr><td align='center'>"+minmax[0]+"</td><td><img  border='1px' width='100%' height='80px' src='/timematrix/scale?s=" + scale + "&lg=" + log + "'/></td><td align='center'>"+minmax[1]+"</td></tr></table></div>");
	
	
		res.write("</div>");
	</server>
	
</view>


function get_density_data( function_name, type )
{
	// Try to load the profile
	var current_prof = catalog.getProfile();

	if( current_prof == undefined )
	{
		return undefined;
	}

	//And now the TM section
	var collector = current_prof["Time_Matrix"];

	if( collector == undefined )
	{
		return undefined;
	}	
	
	var class_array = collector[ "measures" ];
	

	if( class_array == undefined )
	{
		return undefined;
	}		
	
	var i;
	
	for( i = 0 ; i < class_array.length ; i++ )
	{
		if( class_array[i].name == function_name )
		{
			return class_array[i].measures[ type ];
		}
		
	}
	
	
	return undefined;
}



<view uri="map" raw="true">

<server>

	var function_name = GET.f;
	var type = GET.t;

	/* Retrieve the MAP */
	if( (function_name == undefined)||(type == undefined))
	{
		res.end("No selector provided");
		return;
	}

	var map = get_density_data( function_name, type )
	
	if( map == undefined )
	{
		res.end("No such map");
		return;
	}
	
	/* Render TM */
	timeMatrix( res, map.data, GET.w, GET.h, GET.s, GET.g, GET.ls );

</server>


</view>



<view uri="scale" raw="true">

<server>

	var scale_type = GET.s;
	var width = GET.w;
	var height = GET.h;
	
	
	if( width == undefined )
		width = 512;
	
	if( height == undefined )
		height = 80;

	if( (scale_type == undefined))
	{
		scale_type = "temperature";
	}
	
	/* Gen scale image */
	timeMatrixScale( res, scale_type, width,  height, GET.lg);

</server>

</view>


function timeMatrixMinMax( f, t )
{
/* Retrieve the MAP */
	if( (f == undefined)||(t == undefined))
	{
		return [0,0];
	}
	
	var density = get_density_data( f, t );
	
	if( !density )
	{
		return;
	}
	
	var min_string = "";
	var max_string = "";
	
	switch( t )
	{
		case "time":
			min_string = conv.time_unit( density.min );
			max_string = conv.time_unit( density.max );
		break;
		
		case "hits":
			min_string = density.min + " hit(s)";
			max_string = density.max + " hit(s)";
		break;
		
		case "size":
			min_string = conv.size_unit( density.min );
			max_string = conv.size_unit( density.max );	
		break;
	}
	
	return [min_string, max_string];
}

<view uri="minmax" raw="true">

<server>
	var function_name = GET.f;
	var type = GET.t;

	ret = timeMatrixMinMax( function_name, type );
	
	res.end(JSON.stringify( ret ) );
</server>

</view>
