/* ############################ MALP License ############################## */
/* # Fri Jan 18 14:00:00 CET 2013                                         # */
/* # Copyright or (C) or Copr. Commissariat a l'Energie Atomique          # */
/* #                                                                      # */
/* # This software is governed by the CeCILL-C license under French law   # */
/* # and abiding by the rules of distribution of free software.  You can  # */
/* # use, modify and/ or redistribute the software under the terms of     # */
/* # the CeCILL-C license as circulated by CEA, CNRS and INRIA at the     # */
/* # following URL http://www.cecill.info.                                # */
/* #                                                                      # */
/* # The fact that you are presently reading this means that you have     # */
/* # had knowledge of the CeCILL-C license and that you accept its        # */
/* # terms.                                                               # */
/* #                                                                      # */
/* # Authors:                                                             # */
/* #   - BESNARD Jean-Baptiste jean-baptiste.besnard@cea.fr               # */
/* #                                                                      # */
/* ######################################################################## */
#include "Data_Entry.h"
#include "Key_Entry.h"

#include <stdlib.h>
#include <string.h>

struct Data_entry * Data_entry_init( uint64_t key, void *payload, size_t size )
{
	struct Data_entry *ret = malloc( sizeof( struct Data_entry) + size );
	
	if( !ret )
	{
			perror("malloc");
			return NULL;
	}

	ret->lock = 0;
	ret->key = key;
	ret->ref_count = 0;
	ret->size = size;
	ret->been_resubmitted = 0;

	if( payload )
		memcpy((void *)ret->payload, payload, size);
	
	return ret;
	
}

struct Data_entry * Data_entry_clone( struct Data_entry *de )
{
	struct Data_entry *ret = malloc( sizeof( struct Data_entry) + de->size );
	
	if( !ret )
	{
			perror("malloc");
			return NULL;
	}
	
	memcpy((void *)ret, de, sizeof( struct Data_entry) + de->size);
	
	return ret;
}


void Data_entry_release( struct Data_entry *de )
{
	de->lock = 1;
	de->key = 0;
	de->size = 0;
	
	free( de );
}
