#include "Conn_Ctx.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

/*
 * 
 * Connection ctx
 * 
 */



int is_numeric( char * s )
{
	int l = strlen( s );
	
	int i;
	
	for( i = 0 ; i < l ; i++ )
	{
		if( !isdigit(s[i]) )
			return 0;
	}
	
	return 1;
}


int Connection_ctx_init( struct Connection_ctx *ctx, char *uri )
{
	ctx->addr[0] = '\0';
	ctx->port[0] = '\0';
	
	char * fulladdr = strdup(uri);
	
	char *pp = strstr( fulladdr, ":" );
	
	if( !pp )
	{
		printf("Wrong addr format in (%s) expected ADDR:PORT\n", fulladdr);
		return 1;
	}
	
	*pp = '\0';
	
	snprintf(ctx->addr, 256,"%s", fulladdr );
	snprintf(ctx->port, 64,"%s", pp + 1 );
	
	free( fulladdr );
	
	if( strlen(ctx->addr) == 0 )
	{
		printf("Bad address in %s\n", ctx->addr );
		return 1;
	}
		
	if( !strlen(ctx->addr) || !is_numeric(ctx->port) )
	{
		printf("Bad port in %s\n", ctx->port );
		return 1;
	}
	
	
	
	return 0;
}

int Connection_ctx_init_static( struct Connection_ctx *ctx, char * hostname, int port )
{
	snprintf(ctx->addr, 256,"%s", hostname );
	snprintf(ctx->port, 64,"%d", port );
	
	return 0;
}


int Connection_ctx_print(struct Connection_ctx* ctx, char* dest, int len)
{
	if( !ctx )
		return 0;
	
	
	if( !ctx->addr || !ctx->port || !dest )
	{
		return 0;
	}
	
	snprintf(dest, len, "%s:%s", ctx->addr, ctx->port);
	
	return 1;
}


int Connection_ctx_release( struct Connection_ctx *ctx )
{
	ctx->addr[0] = '\0';
	ctx->port[0] = '\0';

	return 0;
}
