#ifndef DATA_PACK_H
#define DATA_PACK_H


#include <pthread.h>
#include <stdint.h>


#define PACK_SIZE_UNIT 1024

struct Data_pack
{
	uint64_t source_id;
	char is_eof;
	size_t size;
	size_t total_size;
	char data[PACK_SIZE_UNIT];
};


struct Data_Unpacker_entry
{
	uint64_t id;
	size_t size;
	size_t offset;
	
	char *data;
	
	struct Data_Unpacker_entry * next;
};



struct Data_Unpacker
{
	struct Data_Unpacker_entry ** entries;
	uint64_t ht_size;
	pthread_mutex_t unpacker_lock;
};



void Data_Unpacker_init( struct Data_Unpacker *du, uint64_t ht_size );
void Data_Unpacker_release( struct Data_Unpacker *du );
char * Data_Unpacker_push( struct Data_Unpacker *du, struct Data_pack *pack );



#endif /* DATA_PACK_H */