#ifndef RED_TREE_DISPATCH_H
#define RED_TREE_DISPATCH_H



#include <pthread.h>
#include "Node_List.h"
#include "Conn_Ctx.h"

struct Red_Dispatcher
{
	struct Node_list * nl;
	pthread_mutex_t nl_lock;
	
	pthread_t server_thread;
	int has_thread;
	struct Connection_ctx server_ctx;
	
	int listening_socket;
};

struct Red_Tree;
char * Red_Tree_Bootstrap_from_env(struct Red_Tree * rt);

int Red_Dispatcher_init( struct Red_Dispatcher *rd );

int Red_Dispatcher_thread( struct Red_Dispatcher *rd );
int Red_Dispatcher_loop(struct Red_Dispatcher* rd);

int Red_Dispatcher_release( struct Red_Dispatcher *rd );



#endif /* RED_TREE_DISPATCH_H */