#ifndef SOCKET_UTILS_H
#define SOCKET_UTILS_H

#include <stdlib.h>

/*
 * 
 * Socket helpers
 * 
 */

/** Bind a socket to an open port
 * @param socket An open socket to bind
 * @return The port on which the socket is listening
 */
int Socket_listen_on_free_port( int* port );
/** Start accepting clients on the socket
 * @param port pointer to an int updated to server listening port if originally 0 (-1 on error)
 * @return new connection's file descriptor (-1 on error)
 */
int Socket_wait_for_a_client( int socket );
/** Connect to a listening socket
 * @param socket An open socket
 * @return new connection's file descriptor
 */
int Socket_connect_to_server( char* addr, char* port );

int Socket_safe_read( int socket, void* dest, size_t size );

int Socket_safe_write( int socket, void* dest, size_t size );









#endif /* SOCKET_UTILS_H */