#include <stdlib.h>
#include <stdio.h>

#ifndef DENSITY_H
#define DENSITY_H

#ifdef __cplusplus
extern "C"
{
#endif

/*
 * Density MAP description :
 
 {
 		"scale" : "temperature" | "ice" | "fire" (...) ,
 		"width" : 1024,
 		"height" : 1024,
 		"logscale" : false,
  		"map" : [
 		
  		[ 1.0, 2.0 , 3.0 ],
  		[ 1.0, 2.0 , 3.0 ],
  		[ 1.0, 2.0 , 3.0 ],
  		[ 1.0, 2.0 , 3.0 ],
  		[ 1.0, 2.0 , 3.0 ]
  
  		]
  }
  
 */


struct Density
{
	void * data;
	size_t size;
};


int Density_init( struct Density * dens , char * json_data );
int Density_dump( struct Density * dens , FILE * dest );
int Density_release( struct Density * dens  );


#ifdef __cplusplus
}
#endif

#endif /* DENSITY_H */
