/* ############################ MALP License ############################## */
/* # Fri Jan 18 14:00:00 CET 2013                                         # */
/* # Copyright or (C) or Copr. Commissariat a l'Energie Atomique          # */
/* #                                                                      # */
/* # This software is governed by the CeCILL-C license under French law   # */
/* # and abiding by the rules of distribution of free software.  You can  # */
/* # use, modify and/ or redistribute the software under the terms of     # */
/* # the CeCILL-C license as circulated by CEA, CNRS and INRIA at the     # */
/* # following URL http://www.cecill.info.                                # */
/* #                                                                      # */
/* # The fact that you are presently reading this means that you have     # */
/* # had knowledge of the CeCILL-C license and that you accept its        # */
/* # terms.                                                               # */
/* #                                                                      # */
/* # Authors:                                                             # */
/* #   - BESNARD Jean-Baptiste jean-baptiste.besnard@cea.fr               # */
/* #                                                                      # */
/* ######################################################################## */
#include <VMPI.h>
#include "VMPI_Wrap.h"

#include <mpi.h>
#include <stdio.h>
#include <stdlib.h>


/* We have a special case for Init and Finalize to init and release the Virtualization interface */

int  MPI_Init(int * argc, char *** argv)
{
	int ret;
	
	ret = PMPI_Init(argc , argv );	

	/* run VMPI init */
	VMPI_Init(argc, argv);
	
	return ret;
}




int MPI_Init_thread(int * argc ,char * * * argv ,int required ,int * provided)
{
	int ret;
	
	/* run MPI init */
	if( (ret = PMPI_Init_thread(argc, argv, required, provided)) != MPI_SUCCESS )
		return -1;

	/* run VMPI init */
	VMPI_Init(argc, argv);

	return ret;
}

int MPI_Finalize()
{
	int ret;
	
	/* Cleanup VMPI */
	VMPI_Release();
	
	ret = PMPI_Finalize();
	
	return ret;

}

/* Lets wrap all MPI functions except those we already defined */

<MALPW !MPI_Init,!MPI_Init_thread,!MPI_Finalize>
MALPW_PROTOTYPE();
{
	MALPW_WRAP( MPI_Comm , * , MACRO_MPI_Comm );
	
	MALPW_CALL(P);
	return ret;
}
</MALPW>

