/* ############################ MALP License ############################## */
/* # Fri Jan 18 14:00:00 CET 2013                                         # */
/* # Copyright or (C) or Copr. Commissariat a l'Energie Atomique          # */
/* #                                                                      # */
/* # This software is governed by the CeCILL-C license under French law   # */
/* # and abiding by the rules of distribution of free software.  You can  # */
/* # use, modify and/ or redistribute the software under the terms of     # */
/* # the CeCILL-C license as circulated by CEA, CNRS and INRIA at the     # */
/* # following URL http://www.cecill.info.                                # */
/* #                                                                      # */
/* # The fact that you are presently reading this means that you have     # */
/* # had knowledge of the CeCILL-C license and that you accept its        # */
/* # terms.                                                               # */
/* #                                                                      # */
/* # Authors:                                                             # */
/* #   - BESNARD Jean-Baptiste jean-baptiste.besnard@cea.fr               # */
/* #                                                                      # */
/* ######################################################################## */

#ifndef VMPI_WRAP_H
#define VMPI_WRAP_H

/**
 * @ingroup Virtual_MPI_
 * @brief Macro used to wrap the MPI communicator.
 * @param _c The requested communicator (must be a variable)
 *
 *   - if MPI_COMM_WORLD is requested, _c is changed to the current partition communicator (VMPI_Get_partition_comm()).
 *   - if @link MPI_COMM_UNIVERSE @endlink is requested, _c is changed to MPI_COMM_WORLD.
 *   - Not changed otherwise
 */
#define MACRO_MPI_Comm(_c) {\
								if (_c==MPI_COMM_WORLD)\
									_c=VMPI_Get_partition_comm();\
								else if( _c==MPI_COMM_UNIVERSE)\
									_c=MPI_COMM_WORLD;\
							}




#endif /* VMPI_WRAP_H */
